<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>21.26. xmlrpc.client — XML-RPC client access &mdash; Python 3.5.1 documentation</title>
    
    <link rel="stylesheet" href="../_static/pydoctheme.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '3.5.1',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/sidebar.js"></script>
    <link rel="search" type="application/opensearchdescription+xml"
          title="Search within Python 3.5.1 documentation"
          href="../_static/opensearch.xml"/>
    <link rel="author" title="About these documents" href="../about.html" />
    <link rel="copyright" title="Copyright" href="../copyright.html" />
    <link rel="top" title="Python 3.5.1 documentation" href="../contents.html" />
    <link rel="up" title="21. Internet Protocols and Support" href="internet.html" />
    <link rel="next" title="21.27. xmlrpc.server — Basic XML-RPC servers" href="xmlrpc.server.html" />
    <link rel="prev" title="21.25. xmlrpc — XMLRPC server and client modules" href="xmlrpc.html" />
    <link rel="shortcut icon" type="image/png" href="../_static/py.png" />
    <script type="text/javascript" src="../_static/copybutton.js"></script>
    <script type="text/javascript" src="../_static/version_switch.js"></script>
    
 

  </head>
  <body role="document">  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="xmlrpc.server.html" title="21.27. xmlrpc.server — Basic XML-RPC servers"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="xmlrpc.html" title="21.25. xmlrpc — XMLRPC server and client modules"
             accesskey="P">previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="internet.html" accesskey="U">21. Internet Protocols and Support</a> &raquo;</li> 
      </ul>
    </div>    

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="module-xmlrpc.client">
<span id="xmlrpc-client-xml-rpc-client-access"></span><h1>21.26. <a class="reference internal" href="#module-xmlrpc.client" title="xmlrpc.client: XML-RPC client access."><code class="xref py py-mod docutils literal"><span class="pre">xmlrpc.client</span></code></a> &#8212; XML-RPC client access<a class="headerlink" href="#module-xmlrpc.client" title="Permalink to this headline">¶</a></h1>
<p><strong>Source code:</strong> <a class="reference external" href="https://hg.python.org/cpython/file/3.5/Lib/xmlrpc/client.py">Lib/xmlrpc/client.py</a></p>
<hr class="docutils" />
<p>XML-RPC is a Remote Procedure Call method that uses XML passed via HTTP as a
transport.  With it, a client can call methods with parameters on a remote
server (the server is named by a URI) and get back structured data.  This module
supports writing XML-RPC client code; it handles all the details of translating
between conformable Python objects and XML on the wire.</p>
<div class="admonition warning">
<p class="first admonition-title">Warning</p>
<p class="last">The <a class="reference internal" href="#module-xmlrpc.client" title="xmlrpc.client: XML-RPC client access."><code class="xref py py-mod docutils literal"><span class="pre">xmlrpc.client</span></code></a> module is not secure against maliciously
constructed data.  If you need to parse untrusted or unauthenticated data see
<a class="reference internal" href="xml.html#xml-vulnerabilities"><span>XML vulnerabilities</span></a>.</p>
</div>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.5: </span>For https URIs, <a class="reference internal" href="#module-xmlrpc.client" title="xmlrpc.client: XML-RPC client access."><code class="xref py py-mod docutils literal"><span class="pre">xmlrpc.client</span></code></a> now performs all the necessary
certificate and hostname checks by default</p>
</div>
<dl class="class">
<dt id="xmlrpc.client.ServerProxy">
<em class="property">class </em><code class="descclassname">xmlrpc.client.</code><code class="descname">ServerProxy</code><span class="sig-paren">(</span><em>uri</em>, <em>transport=None</em>, <em>encoding=None</em>, <em>verbose=False</em>, <em>allow_none=False</em>, <em>use_datetime=False</em>, <em>use_builtin_types=False</em>, <em>*</em>, <em>context=None</em><span class="sig-paren">)</span><a class="headerlink" href="#xmlrpc.client.ServerProxy" title="Permalink to this definition">¶</a></dt>
<dd><div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.3: </span>The <em>use_builtin_types</em> flag was added.</p>
</div>
<p>A <a class="reference internal" href="#xmlrpc.client.ServerProxy" title="xmlrpc.client.ServerProxy"><code class="xref py py-class docutils literal"><span class="pre">ServerProxy</span></code></a> instance is an object that manages communication with a
remote XML-RPC server.  The required first argument is a URI (Uniform Resource
Indicator), and will normally be the URL of the server.  The optional second
argument is a transport factory instance; by default it is an internal
<code class="xref py py-class docutils literal"><span class="pre">SafeTransport</span></code> instance for https: URLs and an internal HTTP
<code class="xref py py-class docutils literal"><span class="pre">Transport</span></code> instance otherwise.  The optional third argument is an
encoding, by default UTF-8. The optional fourth argument is a debugging flag.
If <em>allow_none</em> is true,  the Python constant <code class="docutils literal"><span class="pre">None</span></code> will be translated into
XML; the default behaviour is for <code class="docutils literal"><span class="pre">None</span></code> to raise a <a class="reference internal" href="exceptions.html#TypeError" title="TypeError"><code class="xref py py-exc docutils literal"><span class="pre">TypeError</span></code></a>. This is
a commonly-used extension to the XML-RPC specification, but isn&#8217;t supported by
all clients and servers; see <a class="reference external" href="http://ontosys.com/xml-rpc/extensions.php">http://ontosys.com/xml-rpc/extensions.php</a> for a
description.  The <em>use_builtin_types</em> flag can be used to cause date/time values
to be presented as <a class="reference internal" href="datetime.html#datetime.datetime" title="datetime.datetime"><code class="xref py py-class docutils literal"><span class="pre">datetime.datetime</span></code></a> objects and binary data to be
presented as <a class="reference internal" href="functions.html#bytes" title="bytes"><code class="xref py py-class docutils literal"><span class="pre">bytes</span></code></a> objects; this flag is false by default.
<a class="reference internal" href="datetime.html#datetime.datetime" title="datetime.datetime"><code class="xref py py-class docutils literal"><span class="pre">datetime.datetime</span></code></a> and <a class="reference internal" href="functions.html#bytes" title="bytes"><code class="xref py py-class docutils literal"><span class="pre">bytes</span></code></a> objects may be passed to calls.</p>
<p>The obsolete <em>use_datetime</em> flag is similar to <em>use_builtin_types</em> but it
applies only to date/time values.</p>
<p>Both the HTTP and HTTPS transports support the URL syntax extension for HTTP
Basic Authentication: <code class="docutils literal"><span class="pre">http://user:pass&#64;host:port/path</span></code>.  The  <code class="docutils literal"><span class="pre">user:pass</span></code>
portion will be base64-encoded as an HTTP &#8216;Authorization&#8217; header, and sent to
the remote server as part of the connection process when invoking an XML-RPC
method.  You only need to use this if the remote server requires a Basic
Authentication user and password. If an HTTPS url is provided, <em>context</em> may
be <a class="reference internal" href="ssl.html#ssl.SSLContext" title="ssl.SSLContext"><code class="xref py py-class docutils literal"><span class="pre">ssl.SSLContext</span></code></a> and configures the SSL settings of the underlying
HTTPS connection.</p>
<p>The returned instance is a proxy object with methods that can be used to invoke
corresponding RPC calls on the remote server.  If the remote server supports the
introspection API, the proxy can also be used to query the remote server for the
methods it supports (service discovery) and fetch other server-associated
metadata.</p>
<p><a class="reference internal" href="#xmlrpc.client.ServerProxy" title="xmlrpc.client.ServerProxy"><code class="xref py py-class docutils literal"><span class="pre">ServerProxy</span></code></a> instance methods take Python basic types and objects as
arguments and return Python basic types and classes.  Types that are conformable
(e.g. that can be marshalled through XML), include the following (and except
where noted, they are unmarshalled as the same Python type):</p>
<table border="1" class="docutils">
<colgroup>
<col width="42%" />
<col width="58%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Name</th>
<th class="head">Meaning</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">boolean</span></code></td>
<td>The <a class="reference internal" href="constants.html#True" title="True"><code class="xref py py-const docutils literal"><span class="pre">True</span></code></a> and <a class="reference internal" href="constants.html#False" title="False"><code class="xref py py-const docutils literal"><span class="pre">False</span></code></a>
constants</td>
</tr>
<tr class="row-odd"><td><code class="xref py py-const docutils literal"><span class="pre">integers</span></code></td>
<td>Pass in directly</td>
</tr>
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">floating-point</span> <span class="pre">numbers</span></code></td>
<td>Pass in directly</td>
</tr>
<tr class="row-odd"><td><code class="xref py py-const docutils literal"><span class="pre">strings</span></code></td>
<td>Pass in directly</td>
</tr>
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">arrays</span></code></td>
<td>Any Python sequence type containing
conformable elements. Arrays are returned
as lists</td>
</tr>
<tr class="row-odd"><td><code class="xref py py-const docutils literal"><span class="pre">structures</span></code></td>
<td>A Python dictionary. Keys must be strings,
values may be any conformable type. Objects
of user-defined classes can be passed in;
only their <em>__dict__</em> attribute is
transmitted.</td>
</tr>
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">dates</span></code></td>
<td>In seconds since the epoch.  Pass in an
instance of the <code class="xref py py-class docutils literal"><span class="pre">DateTime</span></code> class or
a <a class="reference internal" href="datetime.html#datetime.datetime" title="datetime.datetime"><code class="xref py py-class docutils literal"><span class="pre">datetime.datetime</span></code></a> instance.</td>
</tr>
<tr class="row-odd"><td><code class="xref py py-const docutils literal"><span class="pre">binary</span> <span class="pre">data</span></code></td>
<td>Pass in an instance of the <code class="xref py py-class docutils literal"><span class="pre">Binary</span></code>
wrapper class or a <a class="reference internal" href="functions.html#bytes" title="bytes"><code class="xref py py-class docutils literal"><span class="pre">bytes</span></code></a> instance.</td>
</tr>
</tbody>
</table>
<p>This is the full set of data types supported by XML-RPC.  Method calls may also
raise a special <code class="xref py py-exc docutils literal"><span class="pre">Fault</span></code> instance, used to signal XML-RPC server errors, or
<code class="xref py py-exc docutils literal"><span class="pre">ProtocolError</span></code> used to signal an error in the HTTP/HTTPS transport layer.
Both <code class="xref py py-exc docutils literal"><span class="pre">Fault</span></code> and <code class="xref py py-exc docutils literal"><span class="pre">ProtocolError</span></code> derive from a base class called
<code class="xref py py-exc docutils literal"><span class="pre">Error</span></code>.  Note that the xmlrpc client module currently does not marshal
instances of subclasses of built-in types.</p>
<p>When passing strings, characters special to XML such as <code class="docutils literal"><span class="pre">&lt;</span></code>, <code class="docutils literal"><span class="pre">&gt;</span></code>, and <code class="docutils literal"><span class="pre">&amp;</span></code>
will be automatically escaped.  However, it&#8217;s the caller&#8217;s responsibility to
ensure that the string is free of characters that aren&#8217;t allowed in XML, such as
the control characters with ASCII values between 0 and 31 (except, of course,
tab, newline and carriage return); failing to do this will result in an XML-RPC
request that isn&#8217;t well-formed XML.  If you have to pass arbitrary bytes
via XML-RPC, use the <a class="reference internal" href="functions.html#bytes" title="bytes"><code class="xref py py-class docutils literal"><span class="pre">bytes</span></code></a> class or the class:<cite>Binary</cite> wrapper class
described below.</p>
<p><code class="xref py py-class docutils literal"><span class="pre">Server</span></code> is retained as an alias for <a class="reference internal" href="#xmlrpc.client.ServerProxy" title="xmlrpc.client.ServerProxy"><code class="xref py py-class docutils literal"><span class="pre">ServerProxy</span></code></a> for backwards
compatibility.  New code should use <a class="reference internal" href="#xmlrpc.client.ServerProxy" title="xmlrpc.client.ServerProxy"><code class="xref py py-class docutils literal"><span class="pre">ServerProxy</span></code></a>.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.5: </span>Added the <em>context</em> argument.</p>
</div>
</dd></dl>

<div class="admonition seealso">
<p class="first admonition-title">See also</p>
<dl class="last docutils">
<dt><a class="reference external" href="http://www.tldp.org/HOWTO/XML-RPC-HOWTO/index.html">XML-RPC HOWTO</a></dt>
<dd>A good description of XML-RPC operation and client software in several languages.
Contains pretty much everything an XML-RPC client developer needs to know.</dd>
<dt><a class="reference external" href="http://xmlrpc-c.sourceforge.net/introspection.html">XML-RPC Introspection</a></dt>
<dd>Describes the XML-RPC protocol extension for introspection.</dd>
<dt><a class="reference external" href="http://www.xmlrpc.com/spec">XML-RPC Specification</a></dt>
<dd>The official specification.</dd>
<dt><a class="reference external" href="http://effbot.org/zone/xmlrpc-errata.htm">Unofficial XML-RPC Errata</a></dt>
<dd>Fredrik Lundh&#8217;s &#8220;unofficial errata, intended to clarify certain
details in the XML-RPC specification, as well as hint at
&#8216;best practices&#8217; to use when designing your own XML-RPC
implementations.&#8221;</dd>
</dl>
</div>
<div class="section" id="serverproxy-objects">
<span id="id1"></span><h2>21.26.1. ServerProxy Objects<a class="headerlink" href="#serverproxy-objects" title="Permalink to this headline">¶</a></h2>
<p>A <a class="reference internal" href="#xmlrpc.client.ServerProxy" title="xmlrpc.client.ServerProxy"><code class="xref py py-class docutils literal"><span class="pre">ServerProxy</span></code></a> instance has a method corresponding to each remote
procedure call accepted by the XML-RPC server.  Calling the method performs an
RPC, dispatched by both name and argument signature (e.g. the same method name
can be overloaded with multiple argument signatures).  The RPC finishes by
returning a value, which may be either returned data in a conformant type or a
<code class="xref py py-class docutils literal"><span class="pre">Fault</span></code> or <code class="xref py py-class docutils literal"><span class="pre">ProtocolError</span></code> object indicating an error.</p>
<p>Servers that support the XML introspection API support some common methods
grouped under the reserved <code class="xref py py-attr docutils literal"><span class="pre">system</span></code> attribute:</p>
<dl class="method">
<dt id="xmlrpc.client.ServerProxy.system.listMethods">
<code class="descclassname">ServerProxy.system.</code><code class="descname">listMethods</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#xmlrpc.client.ServerProxy.system.listMethods" title="Permalink to this definition">¶</a></dt>
<dd><p>This method returns a list of strings, one for each (non-system) method
supported by the XML-RPC server.</p>
</dd></dl>

<dl class="method">
<dt id="xmlrpc.client.ServerProxy.system.methodSignature">
<code class="descclassname">ServerProxy.system.</code><code class="descname">methodSignature</code><span class="sig-paren">(</span><em>name</em><span class="sig-paren">)</span><a class="headerlink" href="#xmlrpc.client.ServerProxy.system.methodSignature" title="Permalink to this definition">¶</a></dt>
<dd><p>This method takes one parameter, the name of a method implemented by the XML-RPC
server. It returns an array of possible signatures for this method. A signature
is an array of types. The first of these types is the return type of the method,
the rest are parameters.</p>
<p>Because multiple signatures (ie. overloading) is permitted, this method returns
a list of signatures rather than a singleton.</p>
<p>Signatures themselves are restricted to the top level parameters expected by a
method. For instance if a method expects one array of structs as a parameter,
and it returns a string, its signature is simply &#8220;string, array&#8221;. If it expects
three integers and returns a string, its signature is &#8220;string, int, int, int&#8221;.</p>
<p>If no signature is defined for the method, a non-array value is returned. In
Python this means that the type of the returned  value will be something other
than list.</p>
</dd></dl>

<dl class="method">
<dt id="xmlrpc.client.ServerProxy.system.methodHelp">
<code class="descclassname">ServerProxy.system.</code><code class="descname">methodHelp</code><span class="sig-paren">(</span><em>name</em><span class="sig-paren">)</span><a class="headerlink" href="#xmlrpc.client.ServerProxy.system.methodHelp" title="Permalink to this definition">¶</a></dt>
<dd><p>This method takes one parameter, the name of a method implemented by the XML-RPC
server.  It returns a documentation string describing the use of that method. If
no such string is available, an empty string is returned. The documentation
string may contain HTML markup.</p>
</dd></dl>

<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.5: </span>Instances of <a class="reference internal" href="#xmlrpc.client.ServerProxy" title="xmlrpc.client.ServerProxy"><code class="xref py py-class docutils literal"><span class="pre">ServerProxy</span></code></a> support the <a class="reference internal" href="../glossary.html#term-context-manager"><span class="xref std std-term">context manager</span></a> protocol
for closing the underlying transport.</p>
</div>
<p>A working example follows. The server code:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="kn">from</span> <span class="nn">xmlrpc.server</span> <span class="k">import</span> <span class="n">SimpleXMLRPCServer</span>

<span class="k">def</span> <span class="nf">is_even</span><span class="p">(</span><span class="n">n</span><span class="p">):</span>
    <span class="k">return</span> <span class="n">n</span><span class="o">%</span><span class="mi">2</span> <span class="o">==</span> <span class="mi">0</span>

<span class="n">server</span> <span class="o">=</span> <span class="n">SimpleXMLRPCServer</span><span class="p">((</span><span class="s">&quot;localhost&quot;</span><span class="p">,</span> <span class="mi">8000</span><span class="p">))</span>
<span class="nb">print</span><span class="p">(</span><span class="s">&quot;Listening on port 8000...&quot;</span><span class="p">)</span>
<span class="n">server</span><span class="o">.</span><span class="n">register_function</span><span class="p">(</span><span class="n">is_even</span><span class="p">,</span> <span class="s">&quot;is_even&quot;</span><span class="p">)</span>
<span class="n">server</span><span class="o">.</span><span class="n">serve_forever</span><span class="p">()</span>
</pre></div>
</div>
<p>The client code for the preceding server:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="kn">import</span> <span class="nn">xmlrpc.client</span>

<span class="k">with</span> <span class="n">xmlrpc</span><span class="o">.</span><span class="n">client</span><span class="o">.</span><span class="n">ServerProxy</span><span class="p">(</span><span class="s">&quot;http://localhost:8000/&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">proxy</span><span class="p">:</span>
    <span class="nb">print</span><span class="p">(</span><span class="s">&quot;3 is even: %s&quot;</span> <span class="o">%</span> <span class="nb">str</span><span class="p">(</span><span class="n">proxy</span><span class="o">.</span><span class="n">is_even</span><span class="p">(</span><span class="mi">3</span><span class="p">)))</span>
    <span class="nb">print</span><span class="p">(</span><span class="s">&quot;100 is even: %s&quot;</span> <span class="o">%</span> <span class="nb">str</span><span class="p">(</span><span class="n">proxy</span><span class="o">.</span><span class="n">is_even</span><span class="p">(</span><span class="mi">100</span><span class="p">)))</span>
</pre></div>
</div>
</div>
<div class="section" id="datetime-objects">
<span id="id2"></span><h2>21.26.2. DateTime Objects<a class="headerlink" href="#datetime-objects" title="Permalink to this headline">¶</a></h2>
<p>This class may be initialized with seconds since the epoch, a time
tuple, an ISO 8601 time/date string, or a <a class="reference internal" href="datetime.html#datetime.datetime" title="datetime.datetime"><code class="xref py py-class docutils literal"><span class="pre">datetime.datetime</span></code></a>
instance.  It has the following methods, supported mainly for internal
use by the marshalling/unmarshalling code:</p>
<dl class="method">
<dt id="xmlrpc.client.DateTime.decode">
<code class="descclassname">DateTime.</code><code class="descname">decode</code><span class="sig-paren">(</span><em>string</em><span class="sig-paren">)</span><a class="headerlink" href="#xmlrpc.client.DateTime.decode" title="Permalink to this definition">¶</a></dt>
<dd><p>Accept a string as the instance&#8217;s new time value.</p>
</dd></dl>

<dl class="method">
<dt id="xmlrpc.client.DateTime.encode">
<code class="descclassname">DateTime.</code><code class="descname">encode</code><span class="sig-paren">(</span><em>out</em><span class="sig-paren">)</span><a class="headerlink" href="#xmlrpc.client.DateTime.encode" title="Permalink to this definition">¶</a></dt>
<dd><p>Write the XML-RPC encoding of this <code class="xref py py-class docutils literal"><span class="pre">DateTime</span></code> item to the <em>out</em> stream
object.</p>
</dd></dl>

<p>It also supports certain of Python&#8217;s built-in operators through rich comparison
and <a class="reference internal" href="../reference/datamodel.html#object.__repr__" title="object.__repr__"><code class="xref py py-meth docutils literal"><span class="pre">__repr__()</span></code></a> methods.</p>
<p>A working example follows. The server code:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="kn">import</span> <span class="nn">datetime</span>
<span class="kn">from</span> <span class="nn">xmlrpc.server</span> <span class="k">import</span> <span class="n">SimpleXMLRPCServer</span>
<span class="kn">import</span> <span class="nn">xmlrpc.client</span>

<span class="k">def</span> <span class="nf">today</span><span class="p">():</span>
    <span class="n">today</span> <span class="o">=</span> <span class="n">datetime</span><span class="o">.</span><span class="n">datetime</span><span class="o">.</span><span class="n">today</span><span class="p">()</span>
    <span class="k">return</span> <span class="n">xmlrpc</span><span class="o">.</span><span class="n">client</span><span class="o">.</span><span class="n">DateTime</span><span class="p">(</span><span class="n">today</span><span class="p">)</span>

<span class="n">server</span> <span class="o">=</span> <span class="n">SimpleXMLRPCServer</span><span class="p">((</span><span class="s">&quot;localhost&quot;</span><span class="p">,</span> <span class="mi">8000</span><span class="p">))</span>
<span class="nb">print</span><span class="p">(</span><span class="s">&quot;Listening on port 8000...&quot;</span><span class="p">)</span>
<span class="n">server</span><span class="o">.</span><span class="n">register_function</span><span class="p">(</span><span class="n">today</span><span class="p">,</span> <span class="s">&quot;today&quot;</span><span class="p">)</span>
<span class="n">server</span><span class="o">.</span><span class="n">serve_forever</span><span class="p">()</span>
</pre></div>
</div>
<p>The client code for the preceding server:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="kn">import</span> <span class="nn">xmlrpc.client</span>
<span class="kn">import</span> <span class="nn">datetime</span>

<span class="n">proxy</span> <span class="o">=</span> <span class="n">xmlrpc</span><span class="o">.</span><span class="n">client</span><span class="o">.</span><span class="n">ServerProxy</span><span class="p">(</span><span class="s">&quot;http://localhost:8000/&quot;</span><span class="p">)</span>

<span class="n">today</span> <span class="o">=</span> <span class="n">proxy</span><span class="o">.</span><span class="n">today</span><span class="p">()</span>
<span class="c"># convert the ISO8601 string to a datetime object</span>
<span class="n">converted</span> <span class="o">=</span> <span class="n">datetime</span><span class="o">.</span><span class="n">datetime</span><span class="o">.</span><span class="n">strptime</span><span class="p">(</span><span class="n">today</span><span class="o">.</span><span class="n">value</span><span class="p">,</span> <span class="s">&quot;%Y%m%dT%H:%M:%S&quot;</span><span class="p">)</span>
<span class="nb">print</span><span class="p">(</span><span class="s">&quot;Today: %s&quot;</span> <span class="o">%</span> <span class="n">converted</span><span class="o">.</span><span class="n">strftime</span><span class="p">(</span><span class="s">&quot;%d.%m.%Y, %H:%M&quot;</span><span class="p">))</span>
</pre></div>
</div>
</div>
<div class="section" id="binary-objects">
<span id="id3"></span><h2>21.26.3. Binary Objects<a class="headerlink" href="#binary-objects" title="Permalink to this headline">¶</a></h2>
<p>This class may be initialized from bytes data (which may include NULs). The
primary access to the content of a <code class="xref py py-class docutils literal"><span class="pre">Binary</span></code> object is provided by an
attribute:</p>
<dl class="attribute">
<dt id="xmlrpc.client.Binary.data">
<code class="descclassname">Binary.</code><code class="descname">data</code><a class="headerlink" href="#xmlrpc.client.Binary.data" title="Permalink to this definition">¶</a></dt>
<dd><p>The binary data encapsulated by the <code class="xref py py-class docutils literal"><span class="pre">Binary</span></code> instance.  The data is
provided as a <a class="reference internal" href="functions.html#bytes" title="bytes"><code class="xref py py-class docutils literal"><span class="pre">bytes</span></code></a> object.</p>
</dd></dl>

<p><code class="xref py py-class docutils literal"><span class="pre">Binary</span></code> objects have the following methods, supported mainly for
internal use by the marshalling/unmarshalling code:</p>
<dl class="method">
<dt id="xmlrpc.client.Binary.decode">
<code class="descclassname">Binary.</code><code class="descname">decode</code><span class="sig-paren">(</span><em>bytes</em><span class="sig-paren">)</span><a class="headerlink" href="#xmlrpc.client.Binary.decode" title="Permalink to this definition">¶</a></dt>
<dd><p>Accept a base64 <a class="reference internal" href="functions.html#bytes" title="bytes"><code class="xref py py-class docutils literal"><span class="pre">bytes</span></code></a> object and decode it as the instance&#8217;s new data.</p>
</dd></dl>

<dl class="method">
<dt id="xmlrpc.client.Binary.encode">
<code class="descclassname">Binary.</code><code class="descname">encode</code><span class="sig-paren">(</span><em>out</em><span class="sig-paren">)</span><a class="headerlink" href="#xmlrpc.client.Binary.encode" title="Permalink to this definition">¶</a></dt>
<dd><p>Write the XML-RPC base 64 encoding of this binary item to the out stream object.</p>
<p>The encoded data will have newlines every 76 characters as per
<a class="reference external" href="http://tools.ietf.org/html/rfc2045#section-6.8">RFC 2045 section 6.8</a>,
which was the de facto standard base64 specification when the
XML-RPC spec was written.</p>
</dd></dl>

<p>It also supports certain of Python&#8217;s built-in operators through <a class="reference internal" href="../reference/datamodel.html#object.__eq__" title="object.__eq__"><code class="xref py py-meth docutils literal"><span class="pre">__eq__()</span></code></a>
and <a class="reference internal" href="../reference/datamodel.html#object.__ne__" title="object.__ne__"><code class="xref py py-meth docutils literal"><span class="pre">__ne__()</span></code></a> methods.</p>
<p>Example usage of the binary objects.  We&#8217;re going to transfer an image over
XMLRPC:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="kn">from</span> <span class="nn">xmlrpc.server</span> <span class="k">import</span> <span class="n">SimpleXMLRPCServer</span>
<span class="kn">import</span> <span class="nn">xmlrpc.client</span>

<span class="k">def</span> <span class="nf">python_logo</span><span class="p">():</span>
    <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s">&quot;python_logo.jpg&quot;</span><span class="p">,</span> <span class="s">&quot;rb&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">handle</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">xmlrpc</span><span class="o">.</span><span class="n">client</span><span class="o">.</span><span class="n">Binary</span><span class="p">(</span><span class="n">handle</span><span class="o">.</span><span class="n">read</span><span class="p">())</span>

<span class="n">server</span> <span class="o">=</span> <span class="n">SimpleXMLRPCServer</span><span class="p">((</span><span class="s">&quot;localhost&quot;</span><span class="p">,</span> <span class="mi">8000</span><span class="p">))</span>
<span class="nb">print</span><span class="p">(</span><span class="s">&quot;Listening on port 8000...&quot;</span><span class="p">)</span>
<span class="n">server</span><span class="o">.</span><span class="n">register_function</span><span class="p">(</span><span class="n">python_logo</span><span class="p">,</span> <span class="s">&#39;python_logo&#39;</span><span class="p">)</span>

<span class="n">server</span><span class="o">.</span><span class="n">serve_forever</span><span class="p">()</span>
</pre></div>
</div>
<p>The client gets the image and saves it to a file:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="kn">import</span> <span class="nn">xmlrpc.client</span>

<span class="n">proxy</span> <span class="o">=</span> <span class="n">xmlrpc</span><span class="o">.</span><span class="n">client</span><span class="o">.</span><span class="n">ServerProxy</span><span class="p">(</span><span class="s">&quot;http://localhost:8000/&quot;</span><span class="p">)</span>
<span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s">&quot;fetched_python_logo.jpg&quot;</span><span class="p">,</span> <span class="s">&quot;wb&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">handle</span><span class="p">:</span>
    <span class="n">handle</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="n">proxy</span><span class="o">.</span><span class="n">python_logo</span><span class="p">()</span><span class="o">.</span><span class="n">data</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="section" id="fault-objects">
<span id="id4"></span><h2>21.26.4. Fault Objects<a class="headerlink" href="#fault-objects" title="Permalink to this headline">¶</a></h2>
<p>A <code class="xref py py-class docutils literal"><span class="pre">Fault</span></code> object encapsulates the content of an XML-RPC fault tag. Fault
objects have the following attributes:</p>
<dl class="attribute">
<dt id="xmlrpc.client.Fault.faultCode">
<code class="descclassname">Fault.</code><code class="descname">faultCode</code><a class="headerlink" href="#xmlrpc.client.Fault.faultCode" title="Permalink to this definition">¶</a></dt>
<dd><p>A string indicating the fault type.</p>
</dd></dl>

<dl class="attribute">
<dt id="xmlrpc.client.Fault.faultString">
<code class="descclassname">Fault.</code><code class="descname">faultString</code><a class="headerlink" href="#xmlrpc.client.Fault.faultString" title="Permalink to this definition">¶</a></dt>
<dd><p>A string containing a diagnostic message associated with the fault.</p>
</dd></dl>

<p>In the following example we&#8217;re going to intentionally cause a <code class="xref py py-exc docutils literal"><span class="pre">Fault</span></code> by
returning a complex type object.  The server code:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="kn">from</span> <span class="nn">xmlrpc.server</span> <span class="k">import</span> <span class="n">SimpleXMLRPCServer</span>

<span class="c"># A marshalling error is going to occur because we&#39;re returning a</span>
<span class="c"># complex number</span>
<span class="k">def</span> <span class="nf">add</span><span class="p">(</span><span class="n">x</span><span class="p">,</span><span class="n">y</span><span class="p">):</span>
    <span class="k">return</span> <span class="n">x</span><span class="o">+</span><span class="n">y</span><span class="o">+</span><span class="mi">0</span><span class="n">j</span>

<span class="n">server</span> <span class="o">=</span> <span class="n">SimpleXMLRPCServer</span><span class="p">((</span><span class="s">&quot;localhost&quot;</span><span class="p">,</span> <span class="mi">8000</span><span class="p">))</span>
<span class="nb">print</span><span class="p">(</span><span class="s">&quot;Listening on port 8000...&quot;</span><span class="p">)</span>
<span class="n">server</span><span class="o">.</span><span class="n">register_function</span><span class="p">(</span><span class="n">add</span><span class="p">,</span> <span class="s">&#39;add&#39;</span><span class="p">)</span>

<span class="n">server</span><span class="o">.</span><span class="n">serve_forever</span><span class="p">()</span>
</pre></div>
</div>
<p>The client code for the preceding server:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="kn">import</span> <span class="nn">xmlrpc.client</span>

<span class="n">proxy</span> <span class="o">=</span> <span class="n">xmlrpc</span><span class="o">.</span><span class="n">client</span><span class="o">.</span><span class="n">ServerProxy</span><span class="p">(</span><span class="s">&quot;http://localhost:8000/&quot;</span><span class="p">)</span>
<span class="k">try</span><span class="p">:</span>
    <span class="n">proxy</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="mi">2</span><span class="p">,</span> <span class="mi">5</span><span class="p">)</span>
<span class="k">except</span> <span class="n">xmlrpc</span><span class="o">.</span><span class="n">client</span><span class="o">.</span><span class="n">Fault</span> <span class="k">as</span> <span class="n">err</span><span class="p">:</span>
    <span class="nb">print</span><span class="p">(</span><span class="s">&quot;A fault occurred&quot;</span><span class="p">)</span>
    <span class="nb">print</span><span class="p">(</span><span class="s">&quot;Fault code: %d&quot;</span> <span class="o">%</span> <span class="n">err</span><span class="o">.</span><span class="n">faultCode</span><span class="p">)</span>
    <span class="nb">print</span><span class="p">(</span><span class="s">&quot;Fault string: %s&quot;</span> <span class="o">%</span> <span class="n">err</span><span class="o">.</span><span class="n">faultString</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="section" id="protocolerror-objects">
<span id="protocol-error-objects"></span><h2>21.26.5. ProtocolError Objects<a class="headerlink" href="#protocolerror-objects" title="Permalink to this headline">¶</a></h2>
<p>A <code class="xref py py-class docutils literal"><span class="pre">ProtocolError</span></code> object describes a protocol error in the underlying
transport layer (such as a 404 &#8216;not found&#8217; error if the server named by the URI
does not exist).  It has the following attributes:</p>
<dl class="attribute">
<dt id="xmlrpc.client.ProtocolError.url">
<code class="descclassname">ProtocolError.</code><code class="descname">url</code><a class="headerlink" href="#xmlrpc.client.ProtocolError.url" title="Permalink to this definition">¶</a></dt>
<dd><p>The URI or URL that triggered the error.</p>
</dd></dl>

<dl class="attribute">
<dt id="xmlrpc.client.ProtocolError.errcode">
<code class="descclassname">ProtocolError.</code><code class="descname">errcode</code><a class="headerlink" href="#xmlrpc.client.ProtocolError.errcode" title="Permalink to this definition">¶</a></dt>
<dd><p>The error code.</p>
</dd></dl>

<dl class="attribute">
<dt id="xmlrpc.client.ProtocolError.errmsg">
<code class="descclassname">ProtocolError.</code><code class="descname">errmsg</code><a class="headerlink" href="#xmlrpc.client.ProtocolError.errmsg" title="Permalink to this definition">¶</a></dt>
<dd><p>The error message or diagnostic string.</p>
</dd></dl>

<dl class="attribute">
<dt id="xmlrpc.client.ProtocolError.headers">
<code class="descclassname">ProtocolError.</code><code class="descname">headers</code><a class="headerlink" href="#xmlrpc.client.ProtocolError.headers" title="Permalink to this definition">¶</a></dt>
<dd><p>A dict containing the headers of the HTTP/HTTPS request that triggered the
error.</p>
</dd></dl>

<p>In the following example we&#8217;re going to intentionally cause a <code class="xref py py-exc docutils literal"><span class="pre">ProtocolError</span></code>
by providing an invalid URI:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="kn">import</span> <span class="nn">xmlrpc.client</span>

<span class="c"># create a ServerProxy with an URI that doesn&#39;t respond to XMLRPC requests</span>
<span class="n">proxy</span> <span class="o">=</span> <span class="n">xmlrpc</span><span class="o">.</span><span class="n">client</span><span class="o">.</span><span class="n">ServerProxy</span><span class="p">(</span><span class="s">&quot;http://google.com/&quot;</span><span class="p">)</span>

<span class="k">try</span><span class="p">:</span>
    <span class="n">proxy</span><span class="o">.</span><span class="n">some_method</span><span class="p">()</span>
<span class="k">except</span> <span class="n">xmlrpc</span><span class="o">.</span><span class="n">client</span><span class="o">.</span><span class="n">ProtocolError</span> <span class="k">as</span> <span class="n">err</span><span class="p">:</span>
    <span class="nb">print</span><span class="p">(</span><span class="s">&quot;A protocol error occurred&quot;</span><span class="p">)</span>
    <span class="nb">print</span><span class="p">(</span><span class="s">&quot;URL: %s&quot;</span> <span class="o">%</span> <span class="n">err</span><span class="o">.</span><span class="n">url</span><span class="p">)</span>
    <span class="nb">print</span><span class="p">(</span><span class="s">&quot;HTTP/HTTPS headers: %s&quot;</span> <span class="o">%</span> <span class="n">err</span><span class="o">.</span><span class="n">headers</span><span class="p">)</span>
    <span class="nb">print</span><span class="p">(</span><span class="s">&quot;Error code: %d&quot;</span> <span class="o">%</span> <span class="n">err</span><span class="o">.</span><span class="n">errcode</span><span class="p">)</span>
    <span class="nb">print</span><span class="p">(</span><span class="s">&quot;Error message: %s&quot;</span> <span class="o">%</span> <span class="n">err</span><span class="o">.</span><span class="n">errmsg</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="section" id="multicall-objects">
<h2>21.26.6. MultiCall Objects<a class="headerlink" href="#multicall-objects" title="Permalink to this headline">¶</a></h2>
<p>The <a class="reference internal" href="#xmlrpc.client.MultiCall" title="xmlrpc.client.MultiCall"><code class="xref py py-class docutils literal"><span class="pre">MultiCall</span></code></a> object provides a way to encapsulate multiple calls to a
remote server into a single request <a class="footnote-reference" href="#id6" id="id5">[1]</a>.</p>
<dl class="class">
<dt id="xmlrpc.client.MultiCall">
<em class="property">class </em><code class="descclassname">xmlrpc.client.</code><code class="descname">MultiCall</code><span class="sig-paren">(</span><em>server</em><span class="sig-paren">)</span><a class="headerlink" href="#xmlrpc.client.MultiCall" title="Permalink to this definition">¶</a></dt>
<dd><p>Create an object used to boxcar method calls. <em>server</em> is the eventual target of
the call. Calls can be made to the result object, but they will immediately
return <code class="docutils literal"><span class="pre">None</span></code>, and only store the call name and parameters in the
<a class="reference internal" href="#xmlrpc.client.MultiCall" title="xmlrpc.client.MultiCall"><code class="xref py py-class docutils literal"><span class="pre">MultiCall</span></code></a> object. Calling the object itself causes all stored calls to
be transmitted as a single <code class="docutils literal"><span class="pre">system.multicall</span></code> request. The result of this call
is a <a class="reference internal" href="../glossary.html#term-generator"><span class="xref std std-term">generator</span></a>; iterating over this generator yields the individual
results.</p>
</dd></dl>

<p>A usage example of this class follows.  The server code:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="kn">from</span> <span class="nn">xmlrpc.server</span> <span class="k">import</span> <span class="n">SimpleXMLRPCServer</span>

<span class="k">def</span> <span class="nf">add</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">y</span><span class="p">):</span>
    <span class="k">return</span> <span class="n">x</span> <span class="o">+</span> <span class="n">y</span>

<span class="k">def</span> <span class="nf">subtract</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">y</span><span class="p">):</span>
    <span class="k">return</span> <span class="n">x</span> <span class="o">-</span> <span class="n">y</span>

<span class="k">def</span> <span class="nf">multiply</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">y</span><span class="p">):</span>
    <span class="k">return</span> <span class="n">x</span> <span class="o">*</span> <span class="n">y</span>

<span class="k">def</span> <span class="nf">divide</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">y</span><span class="p">):</span>
    <span class="k">return</span> <span class="n">x</span> <span class="o">//</span> <span class="n">y</span>

<span class="c"># A simple server with simple arithmetic functions</span>
<span class="n">server</span> <span class="o">=</span> <span class="n">SimpleXMLRPCServer</span><span class="p">((</span><span class="s">&quot;localhost&quot;</span><span class="p">,</span> <span class="mi">8000</span><span class="p">))</span>
<span class="nb">print</span><span class="p">(</span><span class="s">&quot;Listening on port 8000...&quot;</span><span class="p">)</span>
<span class="n">server</span><span class="o">.</span><span class="n">register_multicall_functions</span><span class="p">()</span>
<span class="n">server</span><span class="o">.</span><span class="n">register_function</span><span class="p">(</span><span class="n">add</span><span class="p">,</span> <span class="s">&#39;add&#39;</span><span class="p">)</span>
<span class="n">server</span><span class="o">.</span><span class="n">register_function</span><span class="p">(</span><span class="n">subtract</span><span class="p">,</span> <span class="s">&#39;subtract&#39;</span><span class="p">)</span>
<span class="n">server</span><span class="o">.</span><span class="n">register_function</span><span class="p">(</span><span class="n">multiply</span><span class="p">,</span> <span class="s">&#39;multiply&#39;</span><span class="p">)</span>
<span class="n">server</span><span class="o">.</span><span class="n">register_function</span><span class="p">(</span><span class="n">divide</span><span class="p">,</span> <span class="s">&#39;divide&#39;</span><span class="p">)</span>
<span class="n">server</span><span class="o">.</span><span class="n">serve_forever</span><span class="p">()</span>
</pre></div>
</div>
<p>The client code for the preceding server:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="kn">import</span> <span class="nn">xmlrpc.client</span>

<span class="n">proxy</span> <span class="o">=</span> <span class="n">xmlrpc</span><span class="o">.</span><span class="n">client</span><span class="o">.</span><span class="n">ServerProxy</span><span class="p">(</span><span class="s">&quot;http://localhost:8000/&quot;</span><span class="p">)</span>
<span class="n">multicall</span> <span class="o">=</span> <span class="n">xmlrpc</span><span class="o">.</span><span class="n">client</span><span class="o">.</span><span class="n">MultiCall</span><span class="p">(</span><span class="n">proxy</span><span class="p">)</span>
<span class="n">multicall</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="mi">7</span><span class="p">,</span> <span class="mi">3</span><span class="p">)</span>
<span class="n">multicall</span><span class="o">.</span><span class="n">subtract</span><span class="p">(</span><span class="mi">7</span><span class="p">,</span> <span class="mi">3</span><span class="p">)</span>
<span class="n">multicall</span><span class="o">.</span><span class="n">multiply</span><span class="p">(</span><span class="mi">7</span><span class="p">,</span> <span class="mi">3</span><span class="p">)</span>
<span class="n">multicall</span><span class="o">.</span><span class="n">divide</span><span class="p">(</span><span class="mi">7</span><span class="p">,</span> <span class="mi">3</span><span class="p">)</span>
<span class="n">result</span> <span class="o">=</span> <span class="n">multicall</span><span class="p">()</span>

<span class="nb">print</span><span class="p">(</span><span class="s">&quot;7+3=%d, 7-3=%d, 7*3=%d, 7//3=%d&quot;</span> <span class="o">%</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">result</span><span class="p">))</span>
</pre></div>
</div>
</div>
<div class="section" id="convenience-functions">
<h2>21.26.7. Convenience Functions<a class="headerlink" href="#convenience-functions" title="Permalink to this headline">¶</a></h2>
<dl class="function">
<dt id="xmlrpc.client.dumps">
<code class="descclassname">xmlrpc.client.</code><code class="descname">dumps</code><span class="sig-paren">(</span><em>params</em>, <em>methodname=None</em>, <em>methodresponse=None</em>, <em>encoding=None</em>, <em>allow_none=False</em><span class="sig-paren">)</span><a class="headerlink" href="#xmlrpc.client.dumps" title="Permalink to this definition">¶</a></dt>
<dd><p>Convert <em>params</em> into an XML-RPC request. or into a response if <em>methodresponse</em>
is true. <em>params</em> can be either a tuple of arguments or an instance of the
<code class="xref py py-exc docutils literal"><span class="pre">Fault</span></code> exception class.  If <em>methodresponse</em> is true, only a single value
can be returned, meaning that <em>params</em> must be of length 1. <em>encoding</em>, if
supplied, is the encoding to use in the generated XML; the default is UTF-8.
Python&#8217;s <a class="reference internal" href="constants.html#None" title="None"><code class="xref py py-const docutils literal"><span class="pre">None</span></code></a> value cannot be used in standard XML-RPC; to allow using
it via an extension,  provide a true value for <em>allow_none</em>.</p>
</dd></dl>

<dl class="function">
<dt id="xmlrpc.client.loads">
<code class="descclassname">xmlrpc.client.</code><code class="descname">loads</code><span class="sig-paren">(</span><em>data</em>, <em>use_datetime=False</em>, <em>use_builtin_types=False</em><span class="sig-paren">)</span><a class="headerlink" href="#xmlrpc.client.loads" title="Permalink to this definition">¶</a></dt>
<dd><p>Convert an XML-RPC request or response into Python objects, a <code class="docutils literal"><span class="pre">(params,</span>
<span class="pre">methodname)</span></code>.  <em>params</em> is a tuple of argument; <em>methodname</em> is a string, or
<code class="docutils literal"><span class="pre">None</span></code> if no method name is present in the packet. If the XML-RPC packet
represents a fault condition, this function will raise a <code class="xref py py-exc docutils literal"><span class="pre">Fault</span></code> exception.
The <em>use_builtin_types</em> flag can be used to cause date/time values to be
presented as <a class="reference internal" href="datetime.html#datetime.datetime" title="datetime.datetime"><code class="xref py py-class docutils literal"><span class="pre">datetime.datetime</span></code></a> objects and binary data to be
presented as <a class="reference internal" href="functions.html#bytes" title="bytes"><code class="xref py py-class docutils literal"><span class="pre">bytes</span></code></a> objects; this flag is false by default.</p>
<p>The obsolete <em>use_datetime</em> flag is similar to <em>use_builtin_types</em> but it
applies only to date/time values.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.3: </span>The <em>use_builtin_types</em> flag was added.</p>
</div>
</dd></dl>

</div>
<div class="section" id="example-of-client-usage">
<span id="xmlrpc-client-example"></span><h2>21.26.8. Example of Client Usage<a class="headerlink" href="#example-of-client-usage" title="Permalink to this headline">¶</a></h2>
<div class="highlight-python3"><div class="highlight"><pre><span class="c"># simple test program (from the XML-RPC specification)</span>
<span class="kn">from</span> <span class="nn">xmlrpc.client</span> <span class="k">import</span> <span class="n">ServerProxy</span><span class="p">,</span> <span class="n">Error</span>

<span class="c"># server = ServerProxy(&quot;http://localhost:8000&quot;) # local server</span>
<span class="k">with</span> <span class="n">ServerProxy</span><span class="p">(</span><span class="s">&quot;http://betty.userland.com&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">proxy</span><span class="p">:</span>

    <span class="nb">print</span><span class="p">(</span><span class="n">proxy</span><span class="p">)</span>

    <span class="k">try</span><span class="p">:</span>
        <span class="nb">print</span><span class="p">(</span><span class="n">proxy</span><span class="o">.</span><span class="n">examples</span><span class="o">.</span><span class="n">getStateName</span><span class="p">(</span><span class="mi">41</span><span class="p">))</span>
    <span class="k">except</span> <span class="n">Error</span> <span class="k">as</span> <span class="n">v</span><span class="p">:</span>
        <span class="nb">print</span><span class="p">(</span><span class="s">&quot;ERROR&quot;</span><span class="p">,</span> <span class="n">v</span><span class="p">)</span>
</pre></div>
</div>
<p>To access an XML-RPC server through a proxy, you need to define  a custom
transport.  The following example shows how:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="kn">import</span> <span class="nn">xmlrpc.client</span><span class="o">,</span> <span class="nn">http.client</span>

<span class="k">class</span> <span class="nc">ProxiedTransport</span><span class="p">(</span><span class="n">xmlrpc</span><span class="o">.</span><span class="n">client</span><span class="o">.</span><span class="n">Transport</span><span class="p">):</span>
    <span class="k">def</span> <span class="nf">set_proxy</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">proxy</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">proxy</span> <span class="o">=</span> <span class="n">proxy</span>
    <span class="k">def</span> <span class="nf">make_connection</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">host</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">realhost</span> <span class="o">=</span> <span class="n">host</span>
        <span class="n">h</span> <span class="o">=</span> <span class="n">http</span><span class="o">.</span><span class="n">client</span><span class="o">.</span><span class="n">HTTP</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">proxy</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">h</span>
    <span class="k">def</span> <span class="nf">send_request</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">connection</span><span class="p">,</span> <span class="n">handler</span><span class="p">,</span> <span class="n">request_body</span><span class="p">):</span>
        <span class="n">connection</span><span class="o">.</span><span class="n">putrequest</span><span class="p">(</span><span class="s">&quot;POST&quot;</span><span class="p">,</span> <span class="s">&#39;http://%s%s&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">realhost</span><span class="p">,</span> <span class="n">handler</span><span class="p">))</span>
    <span class="k">def</span> <span class="nf">send_host</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">connection</span><span class="p">,</span> <span class="n">host</span><span class="p">):</span>
        <span class="n">connection</span><span class="o">.</span><span class="n">putheader</span><span class="p">(</span><span class="s">&#39;Host&#39;</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">realhost</span><span class="p">)</span>

<span class="n">p</span> <span class="o">=</span> <span class="n">ProxiedTransport</span><span class="p">()</span>
<span class="n">p</span><span class="o">.</span><span class="n">set_proxy</span><span class="p">(</span><span class="s">&#39;proxy-server:8080&#39;</span><span class="p">)</span>
<span class="n">server</span> <span class="o">=</span> <span class="n">xmlrpc</span><span class="o">.</span><span class="n">client</span><span class="o">.</span><span class="n">Server</span><span class="p">(</span><span class="s">&#39;http://time.xmlrpc.com/RPC2&#39;</span><span class="p">,</span> <span class="n">transport</span><span class="o">=</span><span class="n">p</span><span class="p">)</span>
<span class="nb">print</span><span class="p">(</span><span class="n">server</span><span class="o">.</span><span class="n">currentTime</span><span class="o">.</span><span class="n">getCurrentTime</span><span class="p">())</span>
</pre></div>
</div>
</div>
<div class="section" id="example-of-client-and-server-usage">
<h2>21.26.9. Example of Client and Server Usage<a class="headerlink" href="#example-of-client-and-server-usage" title="Permalink to this headline">¶</a></h2>
<p>See <a class="reference internal" href="xmlrpc.server.html#simplexmlrpcserver-example"><span>SimpleXMLRPCServer Example</span></a>.</p>
<p class="rubric">Footnotes</p>
<table class="docutils footnote" frame="void" id="id6" rules="none">
<colgroup><col class="label" /><col /></colgroup>
<tbody valign="top">
<tr><td class="label"><a class="fn-backref" href="#id5">[1]</a></td><td>This approach has been first presented in <a class="reference external" href="http://web.archive.org/web/20060624230303/http://www.xmlrpc.com/discuss/msgReader$1208?mode=topic">a discussion on xmlrpc.com</a>.</td></tr>
</tbody>
</table>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../contents.html">Table Of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">21.26. <code class="docutils literal"><span class="pre">xmlrpc.client</span></code> &#8212; XML-RPC client access</a><ul>
<li><a class="reference internal" href="#serverproxy-objects">21.26.1. ServerProxy Objects</a></li>
<li><a class="reference internal" href="#datetime-objects">21.26.2. DateTime Objects</a></li>
<li><a class="reference internal" href="#binary-objects">21.26.3. Binary Objects</a></li>
<li><a class="reference internal" href="#fault-objects">21.26.4. Fault Objects</a></li>
<li><a class="reference internal" href="#protocolerror-objects">21.26.5. ProtocolError Objects</a></li>
<li><a class="reference internal" href="#multicall-objects">21.26.6. MultiCall Objects</a></li>
<li><a class="reference internal" href="#convenience-functions">21.26.7. Convenience Functions</a></li>
<li><a class="reference internal" href="#example-of-client-usage">21.26.8. Example of Client Usage</a></li>
<li><a class="reference internal" href="#example-of-client-and-server-usage">21.26.9. Example of Client and Server Usage</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="xmlrpc.html"
                        title="previous chapter">21.25. <code class="docutils literal"><span class="pre">xmlrpc</span></code> &#8212; XMLRPC server and client modules</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="xmlrpc.server.html"
                        title="next chapter">21.27. <code class="docutils literal"><span class="pre">xmlrpc.server</span></code> &#8212; Basic XML-RPC servers</a></p>
<h3>This Page</h3>
<ul class="this-page-menu">
  <li><a href="../bugs.html">Report a Bug</a></li>
  <li><a href="../_sources/library/xmlrpc.client.txt"
         rel="nofollow">Show Source</a></li>
</ul>

<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="xmlrpc.server.html" title="21.27. xmlrpc.server — Basic XML-RPC servers"
             >next</a> |</li>
        <li class="right" >
          <a href="xmlrpc.html" title="21.25. xmlrpc — XMLRPC server and client modules"
             >previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="internet.html" >21. Internet Protocols and Support</a> &raquo;</li> 
      </ul>
    </div>  
    <div class="footer">
    &copy; <a href="../copyright.html">Copyright</a> 1990-2016, Python Software Foundation.
    <br />
    The Python Software Foundation is a non-profit corporation.
    <a href="https://www.python.org/psf/donations/">Please donate.</a>
    <br />
    Last updated on Jan 08, 2016.
    <a href="../bugs.html">Found a bug</a>?
    <br />
    Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.3.3.
    </div>

  </body>
</html>